import java.util.*;
import greenfoot.*;

public class Mars extends World
{
    private GreenfootImage gfImageBG;
    private Color rasterfarbe = new Color(20, 20, 20, 60);
    private Peetie peetie;
    private int gridSize = 50; // Anpassen nach Belieben; Achtung, dann Peeties Groesse aendern! defaultwert = 50
    private int anzahlFighterDrohnen = 7; // nur für E05M02
    public Mars()
    {
        super(900, 600, 1);
        /* --------------- SOUND ---------------- */
        Sound.initializeDefaultSounds(); // Darf nur zu Anfang passieren (--> statische Values)
        this.initializeWorld();
    }

    public void initializeWorld() {
        // Alle Objekte entfernen
        for(Actor a : (List<Actor>)this.getObjects(Actor.class)) {
            this.removeObject(a);
        }
        this.setBackground("marsoberflaeche-960.jpg");
        this.gfImageBG = this.getBackground();

        this.peetie = new Peetie();
        this.addObject(this.peetie, this.peetie.getPeetieStartposX(), this.peetie.getPeetieStartposY());
        this.peetie.setImage("peetie_runter_50.png");

        this.objekteAufWeltSetzen();
        this.createUI();
        Greenfoot.delay(70);
    }

    public void objekteAufWeltSetzen()
    {
        for(int x = 25; x <= 850; x += 50) {
            for(int y = 25; y <= 400; y += 50) {
                this.addObject(new Truemmerteil(), x, y);
            }
        }
        for(int x = 825; x >=600; x -= 50) {
            Truemmerteil t = (Truemmerteil)this.getObjectsAt(x, 225, null).get(0);
            this.removeObject(t);
        }
        this.removeObject((Actor)this.getObjectsAt(625, 275, null).get(0));
        this.addObject(new Batterie(), 625, 275);
        this.removeObject((Actor)this.getObjectsAt(625, 325, null).get(0));
        this.removeObject((Actor)this.getObjectsAt(625, 375, null).get(0));
    }

    public void started() {
        // alle Actor von der Welt entfernen
        List<Actor> actors = (List<Actor>)this.getObjects(Actor.class);
        for(Actor a : actors) {
            this.removeObject(a);
        }
        // Welt neu aufbauen
        this.initializeWorld();
        this.peetie.runOrganize(); // Auskommentieren, wenn Peetie erst nach Klick auf den UI-Run-Knopf anfangen soll
    }

    /**
     * Raster auf der Welt
     */
    public void createGrid()
    {
        this.gfImageBG.setColor(this.rasterfarbe);
        int x = 0;
        while (x <= this.getWidth()) {
            this.gfImageBG.drawLine(x, 0, x, this.getHeight());
            x = x + this.gridSize;
        }
        int y = 0;
        while (y <= this.getHeight()) {
            this.gfImageBG.drawLine(0, y, this.getWidth(), y);
            y = y + this.gridSize;
        }
    }

    public void createUI() {

        /* --------------- TEXTE ENTFERNEN -------- */
        this.alleShowTextTexteLoeschen();

        /* --------------- BuTTONS ---------------- */
        this.buttonsZeigen();

        /* --------------- DIVERS (Logo …) ---------------- */
        Label logo = new Label();
        GreenfootImage g = new GreenfootImage("efm-logo-150x49.png");
        g.setTransparency(80);
        logo.setImage(g);
        this.addObject(logo, 90,30);

        /* --------------- RASTER ---------------- */
        this.createGrid();
    }

    public void buttonsZeigen() { // Nur dann, wenn run-Methode nicht läuft (da sie nicht geklickt werden können, während Peetie run() ausführt)
        // name, shortcut, filestandard, filehover, fileinactive
        Button btRun = new Button("run", "r", "bt_start.png", "bt_start_clicked.png", null);
        this.addObject(btRun, 25, 575);

        Button btSound = new Button("ton", "t", "bt_soundON.png", "bt_soundON_clicked.png", "bt_soundOFF_inactive.png");
        this.addObject(btSound, 65, 575);

        Button btAnleitung = new Button("help", "h", "bt_help.png", "bt_help_clicked.png", null);
        this.addObject(btAnleitung, 105, 575);
    }

    public void buttonsVerstecken() { // während run-Methode läuft
        List<Button> buttonListe = (List<Button>)this.getObjects(Button.class);
        for(Button einButton : buttonListe) { this.removeObject(einButton); }
    }

    public void alleShowTextTexteLoeschen() {
        for(int x = 1; x <= this.getWidth(); x++) {
            for(int y = 1; y <= this.getHeight(); y++) {
                this.showText("", x, y);
            }
        }
    }

    public int getGridSize() {
        return this.gridSize;
    }

    public Peetie getPeetie() {
        return this.peetie;
    }

}
